#!/usr/bin/perl
#
#
#########################
#   M  E  T  A     T  A G     C  R  E  A  T  O R
#########################
#AUTHOR: David Powell
#http://www.matrixvault.com/cgi/
# Copyright 1999, David Powell and "The Matrix Vault"
# A Matrix Vault Production.
# Tested and run on a UNIX system with PERL 5
# This script is an original script by David Powell. You may use it free of charge, if you keep this header intact, 
# along with any other copyright notices found in the resulting HTML output or text files generated by this script. 
# Do not re-distribute this script. For personal use only.
#########################
#
#    Tested on a UNIX system with PERL 5.003
#
$version="1.0";
#
#
#
#########################
#
#    E D I T         V A R I A B L E S 


#  The UNIX path of your mail server.
$sendmail = "/usr/lib/sendmail";

#  Turn e-mailing the tags on/off      1 = on  anything else = off
# If on, you must have the email address posted as 'email'
$email_results = "1";

#  Your E-mail Address. Leave the \ before the @.
$webmaster_email = "yourlogin\@yourisp";

#  The Subject of the results e-mail message
$email_title = "Your Meta Tags";

###################################################


#  READ IN THE POSTED VARIABLES


read (STDIN, $input, $ENV{'CONTENT_LENGTH'});
@pairs = split(/&/, $input);

foreach $pair (@pairs) {

	($name, $value) = split(/=/, $pair);
   	$value =~ tr/+/ /;
   	$value =~ s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
   	$value =~ s/<([^>]|\n)*>//g;
   	$value =~ s/<//g;
   	$value =~ s/>//g;
   	$value =~ s/\*/\\\*/g;
   	$value =~ s/\?/\\\?/g;
   	$value =~ s/\+/\\\+/g;
	$FORM{$name} = $value;
	}

$title = $FORM{'title'};
$description = $FORM{'description'};
$keywords = $FORM{'keywords'};
$owner = $FORM{'owner'};
$refresh = $FORM{'refresh'};
$refreshurl = $FORM{'refreshurl'};
$delay = $FORM{'delay'};
$robot = $FORM{'robot'};
$robotcontrol = $FORM{'robotcontrol'};
$email = $FORM{'email'};
$message = $FORM{'message'};

$outputMAIL = "<META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n";
$outputHTML = "&lt;META HTTP-EQUIV=\"Content-Type\" CONTENT=\"text/html; charset=iso-8859-1\">\n";

#########################
# create_owner
if ($owner eq "")
	{
	&error ("No owner defined!");
	}

	$outputMAIL = $outputMAIL . "<META NAME=\"Author\" CONTENT=\"$owner\">\n";
	$outputHTML = $outputHTML . "&lt;META NAME=\"Author\" CONTENT=\"$owner\">\n";


#########################
# create_description
if ($description eq "")
	{
	&error ("No description defined!");
	}
	$outputMAIL = $outputMAIL .  "<META NAME=\"Description\" CONTENT=\"$description\">\n";
	$outputHTML = $outputHTML . "&lt;META NAME=\"Description\" CONTENT=\"$description\">\n";

#########################
# create_keywords
if ($keywords eq "")
	{
	&error ("No keywords defined- NOT A GOOD IDEA!");
	}
	$outputMAIL = $outputMAIL . "<META NAME=\"KeyWords\" CONTENT=\"$keywords\">\n";
	$outputHTML = $outputHTML . "&lt;META NAME=\"KeyWords\" CONTENT=\"$keywords\">\n";

#########################
# create_title
if ($title eq "")
	{
	&error ("No title defined");
	}
	$outputMAIL = $outputMAIL . "<TITLE>$title</TITLE>\n";
	$outputHTML = $outputHTML .  "&lt;TITLE>$title&lt;/TITLE>\n";

#########################
# Check for Refresh and robot tag

if ($refresh eq "yes"){&create_refresh}
if ($robot eq "yes"){&create_robot}

#########################
sub create_refresh
{
if ($delay eq "")
	{
	$warning = "You did not enter a value for the refresh delay. This means there will be NO delay before the refresh." 
	}
if ($refreshurl eq ""){ 
 	&error ("No refresh URL! Your Refresh tag will not work this way!");
	}
	$outputMAIL = $outputMAIL . "<META HTTP-EQUIV=\"Refresh\" CONTENT=\"$delay\";URL=$refreshurl\">\n";
	$outputHTML = $outputHTML . "&lt;META HTTP-EQUIV=\"Refresh\" CONTENT=\"$delay\";URL=$refreshurl\">\n";

}
#########################
sub create_robot
{
$outputMAIL = $outputMAIL . "<META NAME=\"ROBOTS\" CONTENT=\"$robotcontrol\">\n";
$outputHTML = $outputHTML . "&lt;META NAME=\"ROBOTS\" CONTENT=\"$robotcontrol\">\n";
}


#####################
# Email the Results

$date=localtime(time);
open (REFER, ">>email.log") || &error ("Cannot open email.log");
    print REFER "$date | SITE: $title | $owner | $email\n";
   close (REFER);

if ($email_results eq "1") {

# Check the email address
		if ($email eq ""){&error ("Missing E-mail address.");}
# Mail the tags
	open (MAIL, "|$sendmail -t $email") || die "Can't open $sendmail\n";
	print MAIL "Subject: $email_title\n";
	print MAIL "From: $webmaster_email\n";
	print MAIL "To:$email\n\n";

	open (TEXT, "thanks.txt");
	while (<TEXT>)
	{print MAIL $_;}
	close (TEXT);

	print MAIL qq!
========================================================
$outputMAIL
========================================================

Fueled by Matrix's Meta Tag Generator
Copyright 1999 The Matrix Vault
All rights reserved
http://www.matrixvault.com/
!;}

################
# HTML RESULTS

	print "Content-type: text/html\n\n";

	open(LIST,"HTML_template.html")||die "Can't open HTML_template.html\n";
	@html=<LIST>;
	close(LIST);
	
	$top = $top . qq!<CENTER><FORM name="text">\n!;
	$top = $top . qq!<TEXTAREA name=area rows=8 cols=70>\n!;
	$outputHTML = $top . $outputHTML;
	$outputHTML = $outputHTML . qq!</textarea></FORM></CENTER>\n!;

	foreach $line(@html)
	{
	$line =~s/<\!--INSERT-->/$outputHTML/gi;
	print $line;
	}
	exit;

######################
sub error
{
print "Content-type: text/html\n\n";
print "<HTML><BODY>";
print "<BOLD><FONT COLOR=\"RED\" size=+1>Error:</FONT> $_[0]</FONT><BR>";
print "Press your back button and try again.";
exit;
}

exit;
